Ruby - Bug #15644

ThreadsWait problems with Thread#report_on_exception
03/06/2019 01:20 PM - kke (Kimmo Lehto)

Status: Closed
Priority: Normal
Assignee: keiju (Keiju Ishitsuka)

Target version:

ruby -v: ruby 2.6.1p33 (2019-01-30 revision Backport: 2.4: UNKNOWN, 2.5: UNKNOWN, 2.6:
66950) [x86_64-darwin18] UNKNOWN

Description
Using ThreadsWait with Thread.report_on_exception is confusing.

ThreadsWait spawns a new thread for waiting on a thread:

# thwait.rb:87
def join_nowait (*threads)
threads.flatten!
@threads.concat threads
for th in threads
Thread.start (th) do |t|
begin
t.join
ensure
@wait_queue.push t
end
end
end
end

The t.join in ThreadsWait will re-raise the exceptions that happen in the thread being waited on.

If the thread being waited on was using report_on_exception = false, the wait thread will report the exception and the
report_on_exception = false effectively did nothing, as you still got an exception report.

If the thread was using report_on_exception = true, both threads will report the exception, so you get it twice.

| think this could be fixed by always setting report_on_exception = false for the wait thread.

Example 1

require 'thwait'

thread = Thread.new do
Thread.current.report_on_exception = false
sleep 1
raise "Foo"

end

ThreadsWait.all_waits (thread) do |terminated_thread]

puts "Thread #{terminated_thread} terminated"
end

Expected result

No exception reports

Actual result

The wait thread will report the exception:
#<Thread:0x00007£fa57d092d68@/Users/user/.rbenv/versions/2.6.1/1ib/ruby/2.6.0/thwait.rb:91 run> ter
minated with exception (report_on_exception is true):

Example 2
require 'thwait'
thread = Thread.new do
sleep 1
raise "Foo"
end
ThreadsWait.all _waits (thread) do |terminated_thread]

puts "Thread #{terminated_thread} terminated"
end

Expected result

One exception report

Actual result

Two exception reports:
#<Thread:0x00007£9£83053320Q@test.rb:3 run> terminated with exception (report_on_exception is true)
#<Thread:0x00007£9£f830530a0@/Users/user/.rbenv/versions/2.6.1/1ib/ruby/2.6.0/thwait.rb:91 run> ter

minated with exception (report_on_exception is true):
Traceback (most recent call last):

History

#1 - 03/06/2019 02:23 PM - kke (Kimmo Lehto)

- Description updated

#2 - 03/06/2019 02:26 PM - kke (Kimmo Lehto)

- Description updated

#3 - 03/13/2019 12:04 PM - kke (Kimmo Lehto)

- Description updated

#4 - 10/17/2019 06:49 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Assigned

- Assignee set to keiju (Keiju Ishitsuka)

| agree this is a bug that should be fixed. | have submitted a pull request to fix it: https:/github.com/ruby/thwait/pull/1

#5 - 06/08/2022 03:44 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Assigned to Closed

06/17/2025 22



https://github.com/ruby/thwait/pull/1
http://www.tcpdf.org

